/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.kaki.client.gui;

import java.awt.BorderLayout;
import java.math.BigDecimal;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.eof.EOPlanComptable;
import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.application.common.utilities.CocktailFormats;
import org.cocktail.kaki.client.metier.EOPafEcritures;
import org.cocktail.kaki.common.KakiConstantes;
import org.cocktail.kaki.common.KakiIcones;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class EcrituresView extends javax.swing.JPanel {

    /**
	 * 
	 */
	private static final long serialVersionUID = 2710790863571163637L;
	protected EODisplayGroup eodDebit, eodCredit;
	protected ZEOTable myEOTableDebit, myEOTableCredit;
	protected ZEOTableModel myTableModelDebit, myTableModelCredit;
	protected TableSorter myTableSorterDebit, myTableSorterCredit;

    /** Creates new form TemplateJPanel */
    public EcrituresView(EODisplayGroup displayGroupDebit, EODisplayGroup displayGroupCredit) {

        eodDebit = displayGroupDebit;
        eodCredit = displayGroupCredit;
        
        initComponents();
        initGui();
        
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonPreparer = new javax.swing.JButton();
        tfTotalCredit = new javax.swing.JLabel();
        tfTotalDebit = new javax.swing.JLabel();
        buttonExporter = new javax.swing.JButton();
        buttonImprimer = new javax.swing.JButton();
        jTextField1 = new javax.swing.JTextField();
        jTextField2 = new javax.swing.JTextField();
        viewTableDebit = new javax.swing.JPanel();
        viewTableCredit = new javax.swing.JPanel();
        tfFindCompteDebit = new javax.swing.JTextField();
        tfFindCompteCredit = new javax.swing.JTextField();
        check64 = new javax.swing.JRadioButton();
        check45 = new javax.swing.JRadioButton();
        check18 = new javax.swing.JRadioButton();

        buttonPreparer.setText("Préparer Ecritures");
        buttonPreparer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonPreparerActionPerformed(evt);
            }
        });

        tfTotalCredit.setFont(new java.awt.Font("Tahoma", 0, 12));
        tfTotalCredit.setForeground(new java.awt.Color(51, 51, 255));
        tfTotalCredit.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        tfTotalCredit.setText("jLabel5");

        tfTotalDebit.setFont(new java.awt.Font("Tahoma", 0, 12));
        tfTotalDebit.setForeground(new java.awt.Color(51, 51, 255));
        tfTotalDebit.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        tfTotalDebit.setText("jLabel5");

        buttonExporter.setContentAreaFilled(false);

        buttonImprimer.setContentAreaFilled(false);

        jTextField1.setBackground(new java.awt.Color(255, 204, 204));
        jTextField1.setEditable(false);
        jTextField1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField1.setText("DEBITS");

        jTextField2.setBackground(new java.awt.Color(204, 255, 204));
        jTextField2.setEditable(false);
        jTextField2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField2.setText("CREDITS");

        viewTableDebit.setLayout(new java.awt.BorderLayout());

        viewTableCredit.setLayout(new java.awt.BorderLayout());

        tfFindCompteDebit.setFont(new java.awt.Font("Tahoma", 0, 10));
        tfFindCompteDebit.setMargin(new java.awt.Insets(0, 0, 0, 0));

        tfFindCompteCredit.setFont(new java.awt.Font("Tahoma", 0, 10));
        tfFindCompteCredit.setMargin(new java.awt.Insets(0, 0, 0, 0));

        buttonGroup1.add(check64);
        check64.setText("Visas");

        buttonGroup1.add(check45);
        check45.setText("Paiement");

        buttonGroup1.add(check18);
        check18.setText("Sacd");
        check18.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                check18ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewTableDebit, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 422, Short.MAX_VALUE)
                    .add(jTextField1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 422, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, tfTotalDebit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 130, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(buttonPreparer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 185, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(165, 165, 165)
                        .add(check64, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(layout.createSequentialGroup()
                        .add(check45)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(check18)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 186, Short.MAX_VALUE)
                        .add(buttonImprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonExporter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(viewTableCredit, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 438, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 438, Short.MAX_VALUE)
                    .add(tfTotalCredit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 124, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
            .add(layout.createSequentialGroup()
                .add(75, 75, 75)
                .add(tfFindCompteDebit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 62, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 408, Short.MAX_VALUE)
                .add(tfFindCompteCredit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 62, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(292, 292, 292))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jTextField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 17, Short.MAX_VALUE)
                    .add(jTextField2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 17, Short.MAX_VALUE))
                .add(2, 2, 2)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(tfFindCompteDebit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(tfFindCompteCredit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(1, 1, 1)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewTableDebit, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 317, Short.MAX_VALUE)
                    .add(viewTableCredit, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 317, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tfTotalDebit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(tfTotalCredit))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(buttonExporter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(buttonImprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(buttonPreparer)
                    .add(check45)
                    .add(check64)
                    .add(check18))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

private void buttonPreparerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonPreparerActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_buttonPreparerActionPerformed

private void check18ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_check18ActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_check18ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonExporter;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton buttonImprimer;
    protected javax.swing.JButton buttonPreparer;
    private javax.swing.JRadioButton check18;
    private javax.swing.JRadioButton check45;
    private javax.swing.JRadioButton check64;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField tfFindCompteCredit;
    private javax.swing.JTextField tfFindCompteDebit;
    private javax.swing.JLabel tfTotalCredit;
    private javax.swing.JLabel tfTotalDebit;
    private javax.swing.JPanel viewTableCredit;
    private javax.swing.JPanel viewTableDebit;
    // End of variables declaration//GEN-END:variables

    
    	public javax.swing.JButton getButtonExporter() {
		return buttonExporter;
	}

	public void setButtonExporter(javax.swing.JButton buttonExporter) {
		this.buttonExporter = buttonExporter;
	}

	public javax.swing.JButton getButtonImprimer() {
		return buttonImprimer;
	}

	public void setButtonImprimer(javax.swing.JButton buttonImprimer) {
		this.buttonImprimer = buttonImprimer;
	}

	public javax.swing.JTextField getTfFindCompteCredit() {
		return tfFindCompteCredit;
	}

	public void setTfFindCompteCredit(javax.swing.JTextField tfFindCompteCredit) {
		this.tfFindCompteCredit = tfFindCompteCredit;
	}

	public javax.swing.JTextField getTfFindCompteDebit() {
		return tfFindCompteDebit;
	}

	public void setTfFindCompteDebit(javax.swing.JTextField tfFindCompteDebit) {
		this.tfFindCompteDebit = tfFindCompteDebit;
	}

    
    private void initGui() {
    
    	buttonPreparer.setIcon(KakiIcones.ICON_PARAMS_16);

      	buttonImprimer.setIcon(KakiIcones.ICON_PRINTER_22);
    	buttonExporter.setIcon(KakiIcones.ICON_EXCEL_22);

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

    	ZEOTableModelColumn	col = new ZEOTableModelColumn(eodDebit, EOPafEcritures.GES_CODE_KEY, "UB", 45);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodDebit, EOPafEcritures.PLAN_COMPTABLE_KEY+"."+EOPlanComptable.PCO_NUM_KEY, "Compte", 65);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodDebit, EOPafEcritures.PLAN_COMPTABLE_KEY+"."+EOPlanComptable.PCO_LIBELLE_KEY, "Libellé", 175);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodDebit, EOPafEcritures.ECR_MONT_KEY, "Montant", 75);
    	col.setAlignment(SwingConstants.RIGHT);
		col.setFormatDisplay(CocktailFormats.FORMAT_DECIMAL);
		col.setColumnClass(BigDecimal.class);
    	myCols.add(col);

		myTableModelDebit = new ZEOTableModel(eodDebit, myCols);
		myTableSorterDebit = new TableSorter(myTableModelDebit);

		myEOTableDebit = new ZEOTable(myTableSorterDebit);
		//myEOTableDebit.addListener(myListenerContrat);
		myTableSorterDebit.setTableHeader(myEOTableDebit.getTableHeader());		

		myEOTableDebit.setBackground(KakiConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableDebit.setSelectionBackground(KakiConstantes.COLOR_SELECTED_ROW);
		myEOTableDebit.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableDebit.setLayout(new BorderLayout());
		viewTableDebit.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableDebit.removeAll();
		viewTableDebit.add(new JScrollPane(myEOTableDebit), BorderLayout.CENTER);

                
                
		myCols = new Vector<ZEOTableModelColumn>();

    	col = new ZEOTableModelColumn(eodCredit, EOPafEcritures.GES_CODE_KEY, "UB", 45);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodCredit, EOPafEcritures.PLAN_COMPTABLE_KEY+"."+EOPlanComptable.PCO_NUM_KEY, "Compte", 65);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodCredit, EOPafEcritures.PLAN_COMPTABLE_KEY+"."+EOPlanComptable.PCO_LIBELLE_KEY, "Libellé", 175);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodCredit, EOPafEcritures.ECR_MONT_KEY, "Montant", 75);
    	col.setAlignment(SwingConstants.RIGHT);
		col.setFormatDisplay(CocktailFormats.FORMAT_DECIMAL);
		col.setColumnClass(BigDecimal.class);
    	myCols.add(col);

		myTableModelCredit = new ZEOTableModel(eodCredit, myCols);
		myTableSorterCredit = new TableSorter(myTableModelCredit);

		myEOTableCredit = new ZEOTable(myTableSorterCredit);
		//myEOTableCredit.addListener(myListenerContrat);
		myTableSorterCredit.setTableHeader(myEOTableCredit.getTableHeader());		

		myEOTableCredit.setBackground(KakiConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableCredit.setSelectionBackground(KakiConstantes.COLOR_SELECTED_ROW);
		myEOTableCredit.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableCredit.setLayout(new BorderLayout());
		viewTableCredit.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableCredit.removeAll();
		viewTableCredit.add(new JScrollPane(myEOTableCredit), BorderLayout.CENTER);
    
 
    }

    
    
    
    public javax.swing.JRadioButton getCheck45() {
		return check45;
	}

	public void setCheck45(javax.swing.JRadioButton check45) {
		this.check45 = check45;
	}

	public javax.swing.JRadioButton getCheck64() {
		return check64;
	}

	public void setCheck64(javax.swing.JRadioButton check64) {
		this.check64 = check64;
	}

		public javax.swing.JLabel getTfTotalCredit() {
		return tfTotalCredit;
	}

	public void setTfTotalCredit(javax.swing.JLabel tfTotalCredit) {
		this.tfTotalCredit = tfTotalCredit;
	}
        
	public javax.swing.JLabel getTfTotalDebit() {
		return tfTotalDebit;
	}

	public void setTfTotalDebit(javax.swing.JLabel tfTotalDebit) {
		this.tfTotalDebit = tfTotalDebit;
	}

	public javax.swing.JRadioButton getCheck18() {
		return check18;
	}

	public void setCheck18(javax.swing.JRadioButton check18) {
		this.check18 = check18;
	}

	public ZEOTable getMyEOTableDebit() {
		return myEOTableDebit;
	}

	public void setMyEOTableDebit(ZEOTable myEOTableDebit) {
		this.myEOTableDebit = myEOTableDebit;
	}

	public ZEOTable getMyEOTableCredit() {
		return myEOTableCredit;
	}

	public void setMyEOTableCredit(ZEOTable myEOTableCredit) {
		this.myEOTableCredit = myEOTableCredit;
	}

	public javax.swing.JButton getButtonPreparer() {
		return buttonPreparer;
	}

	public void setButtonPreparer(javax.swing.JButton buttonPreparer) {
		this.buttonPreparer = buttonPreparer;
	}
    
}
